//===================================================================
// Aisa94s.pas
//-------------------------------------------------------------------
// aISA-S94
// Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
// ̃\[Xɂ̓bp[֐̎gpႪLqĂ܂
//===================================================================
unit aisa94s;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
	Aisa94w;

const
	szTitle			= 'Sample';
	szAisa94 	= 'aISA-S94';

type
  TMainForm = class(TForm)
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
		procedure ResultMessage(strbuf:String);
		procedure ErrorMessage(wLogSlot:Word);

  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

procedure TMainForm.FormCreate(Sender: TObject);
var
	strbuf:		String;
	wLogSlot:	Word;
	dwDllVer:	DWord;
	dwDrvVer:	DWord;
	ri:				TAISA94RESOURCE;
	wData:		Word;
	i:				Integer;
	wSat:			Word;
begin
	//-----------------------------------------------------------------
	// Aisa94.dll J
	//-----------------------------------------------------------------
	if Aisa94wDllOpen() = False then begin
		ErrorMessage( AISA94_SLOT_AUTO );
		Halt;
	end;
	//-----------------------------------------------------------------
	// o[W\
	//-----------------------------------------------------------------
	if Aisa94wGetVersion(dwDllVer,dwDrvVer) = False then begin
		ErrorMessage( AISA94_SLOT_AUTO );
		Halt;
	end;
	strbuf:= Format(
						'GetVersion'#10+
						'Dll Version:%08xH'#10+
						'Drv Version:%08xH', [dwDllVer,dwDrvVer]);
	ResultMessage(strbuf);
	//-----------------------------------------------------------------
  // foCX̎gp錾
	//-----------------------------------------------------------------
	wLogSlot:=AISA94_SLOT_AUTO; // 󂫃foCXw
	if Aisa94wCreate( wLogSlot ) = False then begin
		ErrorMessage( AISA94_SLOT_AUTO );
		Halt;
	end;
	strbuf:=Format(
			'aISA-S94 Created'#10+
  		'LogSlot:%2d',[wLogSlot]);
	ResultMessage(strbuf);
	//-----------------------------------------------------------------
	// \[X\
	//-----------------------------------------------------------------
	if Aisa94wGetResource( wLogSlot, @ri ) = False then begin
		ErrorMessage( wLogSlot );
		Halt;
	end;
	strbuf:=Format(
			'aISA-S94 Resource'#10+
			'PortAdr:%04xH - %04xH',
			[ri.dwIOPortBase[1],ri.dwIOPortBase[1]+ri.dwIOPortLength[1]-1]);
	ResultMessage(strbuf);

	///// gkr^pO /////

	//-----------------------------------------------------------------
	// TeCg
	//-----------------------------------------------------------------
	wSat := 3; // TeCgR
	strbuf:=Format(
		'TeCg %d ɐݒ肵܂',[wSat]);
	ResultMessage(strbuf);

	//-----------------------------------------------------------------
	// foCX
	//-----------------------------------------------------------------
	if Aisa94wInitialize( wLogSlot ) = False then begin
		ErrorMessage( wLogSlot );
		Halt;
	end;
	ResultMessage('foCX܂');

	//-----------------------------------------------------------------
	// STeCgɑΉRg[GAɃ[ݒ
	//-----------------------------------------------------------------
	for i := 1 to wSat do begin
		if Aisa94wCtrlWrite( wLogSlot, i, 0 ) = False then begin
			ErrorMessage( wLogSlot );
			Halt;
		end;
	end;
	ResultMessage('Rg[GAɃ[ݒ肵܂');

	//-----------------------------------------------------------------
	// ^p݁i^pJnj
	//-----------------------------------------------------------------
	if Aisa94wStart( wLogSlot, wSat ) = False then begin
		ErrorMessage( wLogSlot );
		Halt;
	end;
	strbuf := Format(
		'^p %d łgkr^pJn܂',[wSat]);
	ResultMessage(strbuf);

	///// ^p̏ /////

	//-----------------------------------------------------------------
	// TeCgԍPɑΉ DiGA̓ǂݍ
	//-----------------------------------------------------------------
	if Aisa94wDin( wLogSlot, 1, wData ) = False then begin
		ErrorMessage( wLogSlot );
		Halt;
	end;
	strbuf := Format(
		'TeCg %d ɑΉDiGA̒l = %Xh',[1,wData] );
	ResultMessage(strbuf);

	//-----------------------------------------------------------------
	// TeCgԍPɑΉ DoGAɒl
	//-----------------------------------------------------------------
	wData:=$AAAA;
	if Aisa94wDout( wLogSlot, 1, wData ) = False then begin
		ErrorMessage( wLogSlot );
		Halt;
	end;
	strbuf := Format(
		'TeCg %d ɑΉDoGA %Xh݂܂',[1,wData] );
	ResultMessage(strbuf);

	///// ^p~ /////

	//-----------------------------------------------------------------
	// ^p~
	//-----------------------------------------------------------------
	if Aisa94wStop(wLogSlot) = False then begin
		ErrorMessage( wLogSlot );
		Halt;
	end;
	ResultMessage('gkr̉^p~܂');

	//-----------------------------------------------------------------
	// foCX
	//-----------------------------------------------------------------
	if Aisa94wClose( wLogSlot ) = False then begin
		ErrorMessage( wLogSlot );
		Halt;
	end;
	strbuf:=Format(
			'aISA-S94 Close'#10+
  		'LogSlot:%2d',[wLogSlot]);
	ResultMessage(strbuf);
	Halt;

end;
//===================================================================
// I
//===================================================================
procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
	Aisa94wDllClose();
end;
//===================================================================
// ʂ\
//===================================================================
procedure TMainForm.ResultMessage(strbuf:String);
begin
	Application.MessageBox(PChar(strbuf), szTitle, MB_OK + MB_ICONINFORMATION);
end;
//===================================================================
// G[bZ[W\
//===================================================================
procedure TMainForm.ErrorMessage(wLogSlot:Word);
var
	dwRes:	DWord;
	strbuf:	String;
begin
	dwRes:=Aisa94wGetLastError(wLogSlot);
	if dwRes = AISA94_ERR_WRAPDLL then begin
		strbuf:='DLL Load error';
	end else begin
		strbuf:=Format(
							'aISA-S94 error'#10#10'Error code:%08xH',[dwRes]);
	end;
	Application.MessageBox(PChar(strbuf), szTitle, MB_OK + MB_ICONSTOP);
end;

end.

